// ***** BEGIN LICENSE BLOCK *****
// Version: MPL 1.1/GPL 2.0/LGPL 2.1
//
// The contents of this file are subject to the Mozilla Public License Version
// 1.1 (the "License"); you may not use this file except in compliance with
// the License. You may obtain a copy of the License at
// http://www.mozilla.org/MPL/
//
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
//
// The Original Code is mozilla.org code.
//
// The Initial Developer of the Original Code is
// the Mozilla Organization.
// Portions created by the Initial Developer are Copyright (C) 1998-2002
// the Initial Developer. All Rights Reserved.
//
// Contributor(s):
//   Robert Kaiser <KaiRo@KaiRo.at>
//   Nagarjuna Venna (vnagarjuna@yahoo.com)
//   Martijn Ras (Martijn.Ras@Cable4U.nl)
//
// Alternatively, the contents of this file may be used under the terms of
// either the GNU General Public License Version 2 or later (the "GPL"), or
// the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
// in which case the provisions of the GPL or the LGPL are applicable instead
// of those above. If you wish to allow use of your version of this file only
// under the terms of either the GPL or the LGPL, and not to allow others to
// use your version of this file under the terms of the MPL, indicate your
// decision by deleting the provisions above and replace them with the notice
// and other provisions required by the GPL or the LGPL. If you do not delete
// the provisions above, a recipient may use your version of this file under
// the terms of any one of the MPL, the GPL or the LGPL.
//
// ***** END LICENSE BLOCK *****

// --- strings specific to that single Language Pack ---
var language   = "nl";
var name       = "Nederlands";
var region     = "NL";
var size       = 700;
var version    = "1.7";
var chromeNode = language + "-" + region;
// --- end pack-specific strings ---

// this function converts an error number to the error code
function ErrorCodenr (errornum) {
	if (errornum == 0)  {
		errorstring = "SUCCES";
	} else if (errornum == -200)  {
		errorstring = "FOUTE_PAKKET_NAAM";
	} else if (errornum == -201) {
		errorstring = "ONVERWACHTE_FOUT";
	} else if (errornum == -202) {
		errorstring = "TOEGANG_GEWEIGERD";
	} else if (errornum == -203) {
		errorstring = "TE_VEEL_CERTIFICATEN";
	} else if (errornum == -204) {
		errorstring = "GEEN_INSTALLATIE_SCRIPT";
	} else if (errornum == -205) {
		errorstring = "GEEN_CERTIFICAAT";
	} else if (errornum == -206) {
		errorstring = "GEEN_OVEREENKOMEND_CERTIFICAAT";
	} else if (errornum == -207) {
		errorstring = "KAN_ARCHIEF_NIET_LEZEN";
	} else if (errornum == -208) {
		errorstring = "FOUTE_ARGUMENTEN";
	} else if (errornum == -209) {
		errorstring = "ILLEGAAL_RELATIEF_PAD";
	} else if (errornum == -210) {
		errorstring = "AFGEBROKEN_DOOR_GEBRUIKER";
	} else if (errornum == -211) {
		errorstring = "INSTALLATIE_NIET_GESTART";
	} else if (errornum == -212) {
		errorstring = "STILLE_MODUS_GEWEIGERD";
	} else if (errornum == -213) {
		errorstring = "NIET_ZO_EEN_COMPONENT";
	} else if (errornum == -214) {
		errorstring = "BESTAAT_NIET";
	} else if (errornum == -215) {
		errorstring = "ALLEEN_LEZEN";
	} else if (errornum == -216) {
		errorstring = "IS_MAP";
	} else if (errornum == -217) {
		errorstring = "NETWERK_BESTAND_IS_IN_GEBRUIK";
	} else if (errornum == -218) {
		errorstring = "APPLE_ENKELE_FOUT";
	} else if (errornum == -219) {
		errorstring = "ONGELDIG_PAD_FOUT";
	} else if (errornum == -220) {
		errorstring = "PATCH_SLECHTE_DIFF";
	} else if (errornum == -221) {
		errorstring = "PATCH_SLECHT_CHECKSUM_DOEL";
	} else if (errornum == -222) {
		errorstring = "PATCH_SLECHT_CHECKSUM_RESULTAAT";
	} else if (errornum == -223) {
		errorstring = "DEINSTALLATIE_MISLUKT";
	} else if (errornum == -224) {
		errorstring = "PACKKET_MAP_NIET_INGESTELD";
	} else if (errornum == -225) {
		errorstring = "EXTRACTIE_MISLUKT";
	} else if (errornum == -226) {
		errorstring = "BESTANDSNAAM_REEDS_GEBRUIKT";
	} else if (errornum == -227) {
		errorstring = "INSTALLATIE_AFGEBROKEN";
	} else if (errornum == -228) {
		errorstring = "OPHAAL_FOUT";
	} else if (errornum == -229) {
		errorstring = "SCRIPT_FOUT";
	} else if (errornum == -230) {
		errorstring = "BESTAAT_REEDS";
	} else if (errornum == -231) {
		errorstring = "IS_BESTAND";
	} else if (errornum == -232) {
		errorstring = "BRON_BESTAAT_NIET";
	} else if (errornum == -233) {
		errorstring = "BRON_IS_MAP";
	} else if (errornum == -234) {
		errorstring = "BRON_IS_BESTAND";
	} else if (errornum == -235) {
		errorstring = "ONVOLDOENDE_SCHIJFRUIMTE";
	} else if (errornum == -236) {
		errorstring = "BESTANDSNAAM_TE_LANG";
	} else if (errornum == -237) {
		errorstring = "NIET_IN_STAAT_LIB_FUNCTIE_TE_LOCALISEREN";
	} else if (errornum == -238) {
		errorstring = "NIET_IN_STAAT_LIBRARY_TE_LADEN";
	} else if (errornum == -239) {
		errorstring = "CHROME_REGISTRATIE_FOUT";
	} else if (errornum == -240) {
		errorstring = "ONGELDIGE_INSTALLATIE";
	} else if (errornum == -299) {
		errorstring = "GEHEUGENTEKORT";
	} else if (errornum == 999) {
		errorstring = "HERSTART_BENODIGD";
	} else if (errornum == -5550) {
		errorstring = "GESTALT_ONBEKENDE_FOUT";
	} else if (errornum == -5551) {
		errorstring = "GESTALT_ONGELDIG_ARGUMENT";
	} else {
		errorstring = "Fout Nr. " + errornum;
	}
	return errorstring;
}

// this function converts an error number to a string with code and number
function ErrorWithCode (error) {
	return error + " (" + ErrorCode (error) + ")";
}

// OS type detection - which platform?
function getPlatform () {
	var platformStr;
	var platformNode;
	if ('platform' in Install) {
		platformStr = new String (platform);
		if (! platformStr.search (/^Macintosh/)) {
			platformNode = 'mac';
		} else if (! platformStr.search (/^Win/)) {
			platformNode = 'win';
		} else {
			platformNode = 'unix';
		}
	} else {
		var fOSMac  = getFolder ("Mac System");
		var fOSWin  = getFolder ("Win System");
		if (fOSMac != null) {
			platformNode = 'mac';
		} else if (fOSWin != null) {
			platformNode = 'win';
		} else {
			platformNode = 'unix';
		}
	}
	return platformNode;
}

// this function verifies disk space in kilobytes
function verifyDiskSpace (dirPath, spaceRequired) {
	var spaceAvailable;
	// Get the available disk space on the given path
	spaceAvailable = fileGetDiskSpaceAvailable (dirPath);
	// Convert the available disk space into kilobytes
	spaceAvailable = parseInt (spaceAvailable / 1024);
	// do the verification
	if (spaceAvailable < spaceRequired) {
		logComment ("Onvoldoende schijfruimte: " + dirPath);
		logComment ("             benodigd   : " + spaceRequired + " KB");
		logComment ("             beschikbaar: " + spaceAvailable + " KB");
		return false;
	}
	return true;
}

// *** start main install routine ***
var initerror = initInstall (name, "locales/mozilla/" + chromeNode, version); 
if (initerror == 0) {
	var fProgram = getFolder ("Program");
	if (! verifyDiskSpace (fProgram, size)) {
		cancelInstall (INSUFFICIENT_DISK_SPACE);
	} else {
		var localeName   = "locale/" + chromeNode + "/";
		var platformNode = getPlatform ();
		var regionName   = "locale/" + region + "/";

		logComment ("Platform gedetecteerd als: " + platformNode);
		logComment ("Programmamap             : " + fProgram);

		var wantGlobalInstall = true;
		var adderror;
		// ask for global or profile install
		if (confirm ("Dit proces zal het taalpakket globaal (in de map chrome van het bladerprogramma) ofwel lokaal (in de map chrome van uw huidige profiel) installeren. Het voordeel van een globale installatie is dat het slechts eenmaal ge\u00EFnstalleerd hoeft te worden en beschikbaar wordt aan alle profielen (vergelijkbaar met het engelse taal pakket). Het nadeel is dat u mogelijk beheerdersrechten nodig heeft om dat te doen.\n\nPrefereert u een globale installatie? (Annuleren zal een lokale installatie uitvoeren.)")) {
			logComment ("Globale installatie gekozen.");
			adderror = addDirectory ("", "chrome", fProgram, "chrome");
			if (adderror != 0) {
				logComment ("AddDirectory () voor mislukt voor: " + fProgram + "chrome: " + ErrorWithCode (adderror));
				// Reset and try to install into the profile instead
				resetError ();
				wantGlobalInstall = false;
				logComment ("Zal proberen lokale installatie uit te voeren.");
			}
		}
		if (! wantGlobalInstall) {
			logComment ("Lokale installatie gekozen.");
			fProgram = getFolder ("Profile");
			if (verifyDiskSpace (fProgram, size)) {
				adderror = addDirectory ("", "chrome", fProgram, "chrome");
				if (adderror != 0) {
					logComment ("AddDirectory () voor mislukt voor: " + fProgram + "chrome: " + ErrorWithCode (adderror));
					cancelInstall (adderror);
				}
			} else {
				cancelInstall (INSUFFICIENT_DISK_SPACE);
			}
		}
		var alertstring;
		if (adderror == 0) {
			setPackageFolder (fProgram);

			// register chrome
			var cf = getFolder (fProgram, "chrome/" + chromeNode + ".jar");
			var pf = getFolder (fProgram, "chrome/" + language + "-" + platformNode + ".jar");
			var rf = getFolder (fProgram, "chrome/" + region + ".jar");

			registerChrome (LOCALE, cf, localeName + "p3p/");
			registerChrome (LOCALE, cf, localeName + "help/");
			registerChrome (LOCALE, cf, localeName + "necko/");
			registerChrome (LOCALE, cf, localeName + "communicator/");
			registerChrome (LOCALE, cf, localeName + "navigator/");
			registerChrome (LOCALE, cf, localeName + "autoconfig/");
			registerChrome (LOCALE, cf, localeName + "chatzilla/");
			registerChrome (LOCALE, cf, localeName + "cookie/");
			registerChrome (LOCALE, cf, localeName + "editor/");
			registerChrome (LOCALE, cf, localeName + "global/");
			registerChrome (LOCALE, cf, localeName + "mozldap/");
			registerChrome (LOCALE, cf, localeName + "messenger-smime/");
			registerChrome (LOCALE, cf, localeName + "pipnss/");
			registerChrome (LOCALE, cf, localeName + "pippki/");
			//registerChrome (LOCALE, cf, localeName + "venkman/");
			registerChrome (LOCALE, cf, localeName + "wallet/");
			registerChrome (LOCALE, cf, localeName + "messenger/");
			registerChrome (LOCALE, cf, localeName + "content-packs/");
			//registerChrome (LOCALE, cf, localeName + "inspector/");
			registerChrome (LOCALE, rf, regionName + "navigator-region/");
			registerChrome (LOCALE, rf, regionName + "editor-region/");
			registerChrome (LOCALE, rf, regionName + "messenger-region/");
			registerChrome (LOCALE, rf, regionName + "communicator-region/");
			registerChrome (LOCALE, rf, regionName + "global-region/");
			registerChrome (LOCALE, pf, localeName + "navigator-platform/");
			registerChrome (LOCALE, pf, localeName + "global-platform/");
			registerChrome (LOCALE, pf, localeName + "communicator-platform/");
			if (platformNode == 'win') {
				registerChrome (LOCALE, pf, localeName + "messenger-mapi/");
			}

			var installerror = performInstall (); 
			if (installerror >= 0) {
				if (wantGlobalInstall) {
					alertstring = "Taalpakket succesvol globaal ge\u00EFnstalleerd. Het zal beschikbaar zijn aan alle profielen."
				} else {
					alertstring = "Taalpakket succesvol ge\u00EFnstalleerd in uw profielmap. Het zal slechts beschikbaar zijn aan het huidige profiel.";
				}
				alertstring = alertstring + "\n\nOm over te schakelen naar het nieuw ge\u00EFnstalleerde taalpakket, selecteer het via Edit > Preferences (Category: Appearance > Languages/Content).";
				if (installerror == 999) {
					alertstring = alertstring + "\n\nU dient uw systeem te herstarten om de installatie van het taalpakket af te ronden.";
				}
			} else {
				alertstring = "Installatie mislukt. Foutcode was: " + ErrorWithCode (installerror);
				cancelInstall (installerror);
			}
		} else {
			if ((adderror == -202) || (adderror == -215)) {
				alertstring = "Installeer alstublieft als root / systeembeheerder, het lijkt erop dat u geen schrijfrechten heeft in de Mozilla map: " + fProgram;
			} else {
				alertstring = "Installatie mislukt. Foutcode was: " + ErrorWithCode (adderror);
			}
			cancelInstall (adderror);
		}
		logComment (alertstring);
		alert (alertstring);
	}
} else {
	logComment ("initInstall: " + ErrorWithCode (initerror));
	cancelInstall (initerror);
}
